
/*
     for very long chains, create_mvisits can be very slow.
     */

:- ensure_loaded( library(system) ).          % shell/1.
:- ensure_loaded( '../src/init_lib' ).

:- requires( to_list/2 ).
:- requires( sys_info/1 ).
:- requires( flatoms/2 ).
:- requires( kv_write_transpose/2 ).
:- requires( read_terms/2 ).
:- requires( write_terms/2 ).
% :- requires( increase_contiguous_count/3 ).

fast_mvisits_from_fstays( FstaysOr ) :-
     to_list( FstaysOr, Fstays ),
     fast_mvisits_from_fstays_1( Fstays ).

fast_mvisits_from_fstays_1( [] ).
fast_mvisits_from_fstays_1( [H|T] ) :-
     atom_concat( Stem, '.fstays', H ),
     atom_concat( Stem, '.srt_fstays', SrtH ),
     atom_concat( Stem, '.fmvisits', MviH ),
     flatoms( ['sort ', H, ' > ', SrtH], Sort ),
     sys_info( Sort ),
     open( SrtH, read, In ),
     read( In, Fst ),
     fast_mvisits_from_stream( Fst, In, [], Cnts ),
     close( In ),
     open( MviH, write, Out ),
     kv_write_transpose( Cnts, Out ),
     close( Out ),
     % this sort is less mem consuming in Yap !!! change it...
     read_terms( MviH, RKvs ),
     keysort( RKvs, SrtKvs ),
     reverse( SrtKvs, RevKvs ),
     write_terms( MviH, RevKvs ),
     /*
     atom_concat( Stem, '.fmvisits_tmp', MviTmp ),
     flatoms( ['sort -g -r ',MviH,' > ', MviTmp], SortFmv ),
     sys_info( SortFmv ),
     flatoms( ['mv ', MviTmp, ' ', MviH], Mv ), 
     sys_info( Mv ),
     */
     delete_file( SrtH ),
     fast_mvisits_from_fstays_1( T ).

fast_mvisits_from_stream( end_of_file, _In, Cnts, Cnts ).
fast_mvisits_from_stream( Mod-Tms, In, Acc, Cnts ) :-
     increase_contiguous_count_by( Acc, Mod, Tms, NxtAcc ),
     read( In, Next ),
     fast_mvisits_from_stream( Next, In, NxtAcc, Cnts ).

increase_contiguous_count_by( [], ReadTerm, By, [ReadTerm-By] ).
increase_contiguous_count_by( [H-Hcount|T], ReadTerm, By, NxAcc ) :-
	( \+ H = ReadTerm ->
		NxAcc = [ReadTerm-By,H-Hcount|T]
		;
		NxHcount is Hcount + By,
		NxAcc = [H-NxHcount|T]
	).
