
:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(opts_have_help) ).

proposed_asia( Opts ) :-
	opts_have_help( Opts ),
	!,
	write( 'proposed_asia:      look into a number of argument files to see' ), nl,
	write( '                    the Asia BN was proposed.' ), nl, nl,
	write( ' Options.' ), nl, 
	write( '       grep/1   which to count, b, c or both. Def: c.' ), nl,
	write( '                several MCMC model files.' ), nl, nl.

mention_asia( Opts ) :-
	( select(grep(Wh),Opts,Files) -> 
		true
		; 
		Wh = c,
		Files = Opts
	),
	mention_asia( Files, Wh ).

mention_asia_1( [], _Wh ).
mention_asia_1( [H|T], Wh ) :-
	once( mention_asia_wh_to_pfx( Wh, Pfx ) ),
	atom_concat( Pfx, '[1-[],2-[],3-[1],4-[2],5-[2],6-[3,4],7-[5,6],8-[6]]"', H, Grep ),
	write( H ), write( ': ' ),
	sys_info( Grep ),
	mention_asia( T, Wh ).

mention_asia_wh_to_pfx( b, 'grep -F --count "b(' ).
mention_asia_wh_to_pfx( c, 'grep -F --count "c(' ).
mention_asia_wh_to_pfx( both, 'grep -F --count "' ).
mention_asia_wh_to_pfx( _, 'grep -F --count "c(' ).
