:- ensure_loaded( '../src/all_dynamic'  ).	%
:- ensure_loaded( '../src/ad_to_slp'  ).	%
:- ensure_loaded( '../src/lib/lss'  ).	%

:- ensure_loaded( library(lists) ).	% append/3.
:- ensure_loaded( display_model ).			% /1.

:- ensure_loaded( library(random) ).			% /1.

/*
disp_sbns( bn_un_2p, 10000, stop, [1,2,3,4,5,6,7,8] ). 
disp_sbns( bn_un_2p, 10, donot_stop, [1,2,3,4,5,6,7,8] ). 
disp_sbns( bn_un_2p, 10, donot_stop, [a,b,c,d,e,f,g,h] ). 
*/
dsm( SlpFile, N, Stop, TopPred, InvArgs, ModArgs ) :-
	% atom_codes( SlpFile, FileCs ),
	% bb_get( auxil_dir, AuxilCs ),
	% append( AuxilCs, "/../slp/", PreFxCs ),
	% append( PreFxCs, FileCs, MidFxCs ),
	% append( MidFxCs, ".slp", FullCs ),
	% atom_codes( Full, FullCs ),
	% all_dynamic( Full ),
	% MAYBE instead look into local slp/
	all_dynamic( SlpFile ),
	ad_to_slp( [tmp(googles_tmp)] ),
	% tell( ResFile ),
	gen_and_disp_n_models( N, TopPred, InvArgs, ModArgs, Stop ).
	% told.

gen_and_disp_n_models( N, TopPred, InvArgs, ModArgs, Stop ) :-
	( N =:= 0 ->
		true
		;
		NxN is N - 1,
		copy_term( ModArgs, FreshArgs ),
		to_list( InvArgs, LofInvArgs ),
		to_list( FreshArgs, LofFreshArgs ),
		append( LofInvArgs, LofFreshArgs, TopArgs ),
		Call =.. [TopPred,_A,_B,_C/[]|TopArgs],
		repeat,
		call( slp:Call ),
		!,
		write( model(FreshArgs) ), write( '.' ), nl,
		display_model( FreshArgs ),
		( Stop == stop ->
			write( ' press return to continue (or, q followed by return to quit)' ),
			get_code(Inp), nl,
			( Inp == 0'q ->
				abort
				;
				true
			)
			;
			true
		),
		gen_and_disp_n_models( NxN, TopPred, InvArgs, ModArgs, Stop )
		
		% ( top_sort( Bn, _Sorted ) ->
			% write( c(Bn) ), write( '.' ), nl,
			% gen_bns( NxN, Nodes )
			% ;
			% gen_bns( NxN, Nodes )
			% write( user_error, found_cycle(Bn) ), nl( user_error),
			% abort
		% )
	).

to_list( ListOr, List ) :-
	( is_list( ListOr ) ->
		List = ListOr
		;
		List = [ListOr]
	).
