:- ensure_loaded( '../../src/init_lib' ).
:- requires( kv_decompose_on_max_v/3 ).
:- requires( kvs_add_v_to_matching_k/4 ).

majority_classes( [] ).
majority_classes( [H|T] ) :-
	open( H, read, In ),
	read( In, Fst ),
	majority_classes_on_stream( Fst, In, [], Mjr ),
	close( In ),
	atom_concat( H, '_mjr', Hmjr ),
	open( Hmjr, write, Out ),
	write( Out, Mjr ), write( Out, '.' ), nl( Out ),
	close( Out ),
	majority_classes( T ).

majority_classes_on_stream( end_of_file, _In, Acc, Mjr ) :-
	!,
	Acc = Mjr.
majority_classes_on_stream( Trm, In, Acc, Mjr ) :-
	kv_decompose_on_max_v( Trm, [BstKat|_], _MaxV ),
	kvs_add_v_to_matching_k( Acc, BstKat, 1, NxtAcc ),
	read( In, Nxt ),
	majority_classes_on_stream( Nxt, In, NxtAcc, Mjr ).
