
:- ensure_loaded( '../../src/init_lib' ).
:- elm( 'carts/auxil/bests_in_fterms_file' ).  % /3.
:- elm( 'carts/auxil/gvz_nth' ).         % /1.

:- requires( directory_contents/4 ).
:- requires( break_list_on/4).
:- requires( file_stems_of_files_with_this_ext/3 ).

point_estimates( Consult ) :-
     ensure_loaded( Consult ),
     directory_contents( '.', Files, _Dirs, _Oth ),
     file_stems_of_files_with_this_ext( Files, '.fterms', Stems ),
     point_estimates_these( Stems ).


point_estimates_these( [] ).
point_estimates_these( [H|T] ) :-
     atom_codes( H, HCs ),
     reverse( HCs, RevHCs ),
     once(break_list_on(RevHCs,0'_,RevSeedTknCs,_)),
     reverse( RevSeedTknCs, SeedTknCs ),
     atom_codes( SeedTkn, SeedTknCs ),
     atom_concat( H, '.fterms', File ),
     bests_in_fterms_file( File, _, BlI-_ ),
     Roots = [mvis,mvis_bnw,mvis_e,blhd,blhd_bnw,blhd_e], 
     Files = [Mv1,Mv2,Mv3,Bl1,Bl2,Bl3],
     Core = [file(File),run(false)],
     Core1 = [exec(eog)|Core],
     atom_concat( '_', SeedTkn, Adum ),
     atom_concat_to_all( Roots, Adum, Files ),
     gvz_nth( [out(Mv1),from(1)|Core] ),  % mst vis pscript colour
     gvz_nth( [out(Mv2),from(1),colour(bnw)|Core] ), % monochrom
     gvz_nth( [out(Mv3),from(1),node_style(empty)|Core] ), % has problems
     gvz_nth( [out(Mv1),from(1)|Core1] ),  % mst vis png colour
     gvz_nth( [out(Mv2),from(1),colour(bnw)|Core1] ), % monochrom
     gvz_nth( [out(Mv3),from(1),node_style(empty)|Core1] ), % empty node style
     gvz_nth( [out(Bl1),from(BlI)|Core] ),  % mst vis pscript colour
     gvz_nth( [out(Bl2),from(BlI),colour(bnw)|Core] ), % monochrom
     gvz_nth( [out(Bl3),from(BlI),node_style(empty)|Core] ), % has problems
     gvz_nth( [out(Bl1),from(BlI)|Core1] ),  % mst vis png colour
     gvz_nth( [out(Bl2),from(BlI),colour(bnw)|Core1] ), % monochrom
     gvz_nth( [out(Bl3),from(BlI),node_style(empty)|Core1] ), % empty node style
     point_estimates_these( T ).

atom_concat_to_all( [], _Add, [] ).
atom_concat_to_all( [H|T], Add, [F|Fs] ) :-
     atom_concat( H, Add, F ),
     atom_concat_to_all( T, Add, Fs ).
