:- ensure_loaded( library(lists) ).	% nth/3.
:- ensure_loaded( '../src/cart_llhood' ).
:- ensure_loaded( '../src/display_model' ).

% assumes skeleton/1, and data_pairs/1 are defined.

skel_disp_full( Opts ) :-
	( memberchk(data(DataCall),Opts) ->
		call( DataCall )
		;
		% write( user_error, 'data(Callable), is required. '),
		% nl( user_error ),
		% fail
		true
	),
	data_pairs( DataPairs ),
	data_pairs_to_skeleton_data( DataPairs, 1, Data ),
	findall( NmSk-Skel, skeleton(NmSk,Skel), Skels ),
	skels_disp( Skels, Data ).

skels_disp( [], _Data ).
skels_disp( [ItsName-Skel|TSkels], Data ) :-
	decision_cart_to_cart( Skel, Data, 0, Cart ),
	( cart_llhood( Cart, LLhood ) -> true ; LLhood is 0 ),
	display_model(  Cart, [title(ItsName),lhood(LLhood),balanced(false)] ),
	skels_disp( TSkels, Data ).

data_pairs_to_skeleton_data( [], _N, [] ).
data_pairs_to_skeleton_data( [Flist-Cat|T], N, [d(Flist,Cat,N)|R] ) :-
	NxN is N + 1,
	data_pairs_to_skeleton_data( T, NxN, R ).

decision_cart_to_cart( cart(F,Val,L,R), Data, Depth, cart(F,Val,Cl,Cr) ) :-
	split_data_on_feature( Data, F, Val, LeftD, RightD ),
	NxDepth is Depth + 1,
	decision_cart_to_cart( L, LeftD, NxDepth, Cl ),
	decision_cart_to_cart( R, RightD, NxDepth, Cr ).
decision_cart_to_cart( leaf, Data, Depth, leaf(Depth,Ids) ) :-
	skeleton_data_to_ids( Data, Ids ).

split_data_on_feature( [], _F, _Val, [], [] ).
split_data_on_feature( [d(Flist,Cat,Id)|T], F, Val, LeftD, RightD ) :-
	nth( F, Flist, ListVal ),
	( ListVal > Val ->
		RightD = [d(Flist,Cat,Id)|TRight], LeftD = TLeft
		;
		LeftD = [d(Flist,Cat,Id)|TLeft], RightD = TRight
	),
	split_data_on_feature( T, F, Val, TLeft, TRight ).

skeleton_data_to_ids( [], [] ).
skeleton_data_to_ids( [d(_FList,_Class,Id)|T], [Id|Ids] ) :-
	skeleton_data_to_ids( T, Ids ).
