:- module( edit_diagnostics, [
			diagnostic_plvars_in_vars_list/1,
			diagnostic_plvars_in_cart/1,
			diagnostic_poss_has_fids/1
			] ).

diagnostic_plvars_in_cart( Leaf ) :-
	var( Leaf ), !, write( v(Leaf) ), write( ' , ' ).
diagnostic_plvars_in_cart( cart(_,_,_,_,L,R) ) :-
	!,
	diagnostic_plvars_in_cart( L ),
	diagnostic_plvars_in_cart( R ).
diagnostic_plvars_in_cart( Cart ) :-
	Cart =.. [Name|Args],
	length( Args, Lgth ),
	write( funny_looking_cart(Name/Lgth) ), nl.

diagnostic_plvars_in_vars_list( [] ) :- nl.
diagnostic_plvars_in_vars_list( [_-Var|T] ) :-
	write( r(Var) ), write( ' , ' ),
	diagnostic_plvars_in_vars_list( T ).

diagnostic_poss_has_fids( [] ) :- nl.
diagnostic_poss_has_fids( [f(F,_)|T] ) :-
	write( fid(F) ), write( ' : ' ),
	diagnostic_poss_has_fids( T ).
