% :- module( cmv_branch_mod, [cmv_branch/9] ).
% test efficiency with above, in Sicstus

:- ensure_loaded( library(lists) ).		% reverse/2.
:- ensure_loaded( library(ordsets) ).		% ord_add_element/3, ord_union/3,
                                             % ord_intersection/3,4.

% compile( cmv_branch ), save_modules( [cmv_branch_mod], cmv_branch_mod ), halt.
% cmv_branch( TRvLSplit, RSplit, _ChIds, Edge, J, RmRows, LIds, RIds, LftTbl, RgtTbl ) :-
cmv_branch( TRvLSplit, RSplit, Edge, J, RmRows, LIds, RIds, LftTbl, RgtTbl ) :-
	% RevLSplit = [ChV-ChIds|TRevLSplit],
	% trace,
	till_not_vacuous( TRvLSplit, none__, [], RevNwLFvIdPrs, _, NwLEdge ),
	( RevNwLFvIdPrs == [] ->
		LIds = NwLEdge,
		apply_ids_to_table( RmRows, LIds, LftTbl )
		;
		reverse( RevNwLFvIdPrs, NwLFvIdPrs ),
		union_of_fvidprs( NwLFvIdPrs, NwLEdge, LIds ),
		apply_ids_to_table( RmRows, LIds, NwLRmRows ),
		NwLRow = row(J,NwLFvIdPrs,NwLEdge),
		ord_add_element( NwLRmRows, NwLRow, LftTbl )
	),
	till_not_vacuous( RSplit, _, [], RemRFvIdPrs, RCutFv, RCutIds ),
	( RCutFv == none__ -> 
		RIds = RCutIds,
		apply_ids_to_table( RmRows, RIds, RgtTbl )
		;
		NwRFvIdPrs = [RCutFv-RCutIds|RemRFvIdPrs],
		union_of_fvidprs( NwRFvIdPrs, Edge, RIds ),
		apply_ids_to_table( RmRows, RIds, NwRRmRows ),
		NwRRow = row( J, NwRFvIdPrs, Edge ),
		ord_add_element( NwRRmRows, NwRRow, RgtTbl )
	).

till_not_vacuous( List, LstFv, AccIds, Rem, CutFv, CutIds ) :-
	AccIds = [_,_,_,_,_|_],
	!,
	Rem = List,
	CutFv = LstFv,
	CutIds = AccIds.
till_not_vacuous( [HFv-HIds|T], _LstFv, AccIds, Rem, CutFv, CutIds ) :-
	ord_union( HIds, AccIds, NxAccIds ),
	till_not_vacuous( T, HFv, NxAccIds, Rem, CutFv, CutIds ).

union_of_fvidprs( [], All, All ).
union_of_fvidprs( [_Fv-Ids|T], Acc, All ) :-
	ord_union( Ids, Acc, NxAcc ),
	union_of_fvidprs( T, NxAcc, All ).

apply_ids_to_table( [], _RestrictTo, [] ).
apply_ids_to_table( [H|T], RestrictTo, Restricted ) :-
	H = row( J, FvIdPrs, Edge ),
	apply_ids_to_row( FvIdPrs, Edge, RestrictTo, NwPrs, NwEdge ),
	( NwPrs = [] -> 
		TRestricted = Restricted
		;
		Restricted = [row(J,NwPrs,NwEdge)|TRestricted]
	),
	apply_ids_to_table( T, RestrictTo, TRestricted ).

apply_ids_to_row( FvIdPrs, Edge, RTo, NwPrs, NwEdge ) :-
	apply_ids_to_row_1( FvIdPrs, [], RTo, [], RevPrvNwPrs, RmRTo ), 
	ord_intersection( Edge, RmRTo, PrvNwEdge ),
	% ord_intersection( Edge, RmRTo, PrvNwEdge, Srfl ),
	% just for testing:
	% ( Srfl == [] -> true ; write( dont_like_it ), nl, abort ),
	new_edge( RevPrvNwPrs, PrvNwEdge, NwPrs, NwEdge ).

apply_ids_to_row_1( [], _Acc, RTo, NwPrs, NwPrs, RTo ).
apply_ids_to_row_1( [Fv-Ids|T], Acc, RTo, SeenPrs, NwPrs, RmRTo ) :-
	ord_intersection( Ids, RTo, RstIds, NxRTo ),
	( is_list(Acc) ->
		ord_union( RstIds, Acc, LeftSoFar),
		( LeftSoFar = [_,_,_,_,_|_] ->
			NxAcc is 0,
			NxSeenPrs = [Fv-LeftSoFar|SeenPrs]
			% can reduce to NxSeenPrs = [Fv-LeftSoFar]
			;
			NxAcc = LeftSoFar,
			NxSeenPrs = SeenPrs
		)
		;
		NxAcc is 0,
		( RstIds = [] ->
			NxSeenPrs = SeenPrs
			;
			NxSeenPrs = [Fv-RstIds|SeenPrs]
		)
	),
	apply_ids_to_row_1( T, NxAcc, NxRTo, NxSeenPrs, NwPrs, RmRTo ).

new_edge( [], Edge, [], Edge ).
new_edge( [Fv-Ids|T], Acc, RemPrs, Edge ) :-
	ord_union( Acc, Ids, NxAcc ),
	( NxAcc = [_,_,_,_,_|_] ->
		reverse( [Fv-Ids|T], RemPrs ),
		Edge = Acc,
		NxT = []
		% TRemPrs = _, TEdge = _
		;
		NxT = T,
		TRemPrs = RemPrs,
		TEdge = Edge
	),
	new_edge( NxT, NxAcc, TRemPrs, TEdge ).
