:- ensure_loaded( matrix_aux ).

% nem_mll( Phi, D1, D0, Alpha, Beta, L ) :-
%
% See file nem/R/mLL.R  in bioconductor package "nem"
%
nem_mll_pl( Nem, LogL ) :-
     %  get the stored values :
     nem_d0( D0 ),
     % write( d0 ), nl, matrix_print( D0 ),
     nem_d1( D1 ),
     % write( d1 ), nl, matrix_print( D1 ),
     nem_phi_chi( Phi, Chi ),
     nem_parameter( alpha, Alpha ),
     nem_parameter( beta, Beta ),
     nem_d1_d0_chi_phi( D1Chi, D0Chi, D1Phi, D0Phi ),
     nem_to_matrix( Nem, Phi ),
     %  do the calculations :
     % write( 'Phi :' ), nl, matrix_print( Phi ),
     matrix_copy( Phi, Chi ),
     matrix_apply_expr( Chi, (1-V1), V1 ),
     % write( 'Chi :' ), nl, matrix_print( Chi ),
     % matrix_dims( D0, Dims ),
     %
     %
     matrix_multiplication( D1, Chi, D1Chi ),
     matrix_multiplication( D0, Chi, D0Chi ),
     matrix_multiplication( D1, Phi, D1Phi ),
     matrix_multiplication( D0, Phi, D0Phi ),
     matrix_apply_expr( D1Chi, (Alpha^V2), V2 ),
     matrix_apply_expr( D0Chi, ((1-Alpha)^V3), V3 ),
     matrix_apply_expr( D1Phi, ((1-Beta)^V4), V4 ),
     matrix_apply_expr( D0Phi, (Beta^V4), V4 ),
     % re-cycling D1Chi, which will hold the result of the 3 multiplications.
     % matrix_multiplication( D1Chi,  D0Chi ),
     matrix_op( D1Chi, D0Chi, *, D1Chi ),
     % matrix_multiplication( D1Chi,  D1Phi ),
     matrix_op( D1Chi, D1Phi, *, D1Chi ),
     % matrix_multiplication( D1Chi,  D0Phi ),
     matrix_op( D1Chi, D0Phi, *, D1Chi ),
     % ( parameter( pe, Pe ) -> D1Chi = DiChi * Pe
     % write( 'L ' ), nl, matrix_print( D1Chi ),
     ( (nem_pe(Pe),Pe=[_|_]) -> 
          matrix_op( D1Chi, Pe, *, D1Chi )
          ;
          true
     ),
     % write( 'LP' ), nl, matrix_print( D1Chi ),
     matrix_apply_row( D1Chi, user:log_of_sum, RowLogs ),
     % write( 'RLs' ), nl, write( RowLogs ), nl,
     sum_list( RowLogs, LogL ).

log_of_sum( List, Log ) :-
     sum_list( List, Sum ),
     Log is log( Sum ).

/* here we assume that Phi rows show the children of Ith element.
   i need to double (and triple) check */

nem_to_matrix( Nem, Phi ) :-
     matrix_set_all( Phi, 0 ),
     nem_to_matrix_1( Nem, Phi ).

nem_to_matrix_1( [], _Phi ).
nem_to_matrix_1( [Ch-Pa|T], Phi ) :-
     I is Ch - 1,
     nem_parents_to_matrix( Pa, I, Phi ),
     nem_to_matrix_1( T, Phi ).

nem_parents_to_matrix( [], I, Phi ) :-
     matrix_set( Phi, [I,I], 1 ).
     
nem_parents_to_matrix( [H|T], I, Phi ) :-
     J is H - 1,
     matrix_set( Phi, [J,I], 1 ),
     nem_parents_to_matrix( T, I, Phi ).
