:- ensure_loaded( library(lists) ).		% append/3.
:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(requires) ).		%.
:- requires( sys_info/1 ).

chains_obs_independencies( GzFiles  ) :-
	ensure_loaded( '../auxil/inc_indep' ),
	chains_obs_independencies_1( GzFiles  ).

chains_obs_independencies_1( [] ).
chains_obs_independencies_1( [H|T] ) :-
	atom_concat( Stem, '.gz', H ), 
	atom_concat( 'gunzip ', H, Gunzip ),
	sys_info( Gunzip ),
	% load the appropriate indep/2 file
	atom_codes( Stem, StemCs ),
	append( "cm_t", [FCd,SCd|_], StemCs),
	true_id_codes_to_name( [FCd,SCd], Name ),
	atom_concat( Name, '_inc_findpcs', IpcsName ),
	atom_concat( '../auxil/', IpcsName, AuxName ),
	atom_concat( AuxName, ' ', AuxNameSpc ),
	atom_concat( AuxNameSpc, Stem, FupshArgs ),
	atom_concat( 'fupsh chain_obs_file_independencies ', FupshArgs, Fupsh ),
	sys_info( Fupsh ),
	atom_concat( 'gzip ', Stem, Gzip ),
	sys_info( Gzip ),
	chains_obs_independencies_1( T ).

true_id_codes_to_name( "al", alarm ).
true_id_codes_to_name( "hf", hailfinder ).
true_id_codes_to_name( "sc", insurance ).
true_id_codes_to_name( "p1", parity1 ).
true_id_codes_to_name( "p2", parity2 ).
