:- ensure_loaded( library(lists) ).		% append/3, member/2, memberchk/2.

:- ensure_loaded( '../../src/init_lib' ).
:- ensure_loaded( library(werr) ) 			% /1.

exp_loss_vs_length( Opts ) :-
	exp_loss_vs_length( Defs ), 
	append( Opts, Defs, All ),
	findall( Load,
			( member(load(Load),All),
			  write( consulting(Load) ), nl,
			  consult( Load )
			),
		_Loaded ),
	findall( GzF, member(gz(GzF),All), Gzs ),
	( Gzs = [] -> 
		werr( [['No (gz) model files found at input. Please use gz/1 option.']
		       ['Also see exp_loss_vs_length([help])'] ] ),
		;
		findall( Loss, member(loss(Loss),All), Losses ),
		( Losses = [] ->
			werr( [['No loss functions found at input. Please use loss/1 option.']
		    	       ['Also see exp_loss_vs_length([help])'] ] ),
			;
			memberchk( multi(Multi), All ),
			exp_loss_vs_length_graphs( Gzs, Losses, Multi )
