% This script reproduces results similar to those reported in Table 1.
% Because of the evolution of the software, the numbers reproduced are
% comparable to those reported, but not identical.
% To produce the table entries:
% (a)   run the experiment by starting a prolog (SICStus or Yap), and
%       compile( run_tbl1 )
%       run_tbl1
%       halt.
% (b)   cd into out_uai01_tbl1 or other directory you have chosen and 
%       see file tr_cd0_rm_slb_asia_10k_tabled_i1M__s1.mvisits

:- ensure_loaded( '../../run' ).
:- elm( 'bns/src/llhood/lhood_canonical_uai01' ).
:- elm( 'auxil/create_mvisits' ).

slb_asia_10k.
data_format( data(_,_,_) ).
possible_values( _, [0,1] ).

run_tbl1 :-
	% Dir = '/local/d0p6/nicos/uai01_tbl1',
	Dir = uai01_tbl1,
	Runs = [
			runs_file( runs_tbl1 ),
		 	results_dir( Dir ),
			print([24,28,29,31])
		],
	run( Runs ).
