:- dynamic model_llhood_cached/2.

lhood_canonical(Mst,_Mi,LLst,LLi,Ratio) :-
	% write( user_error, model_llhood_eff(Mst,LLst) ), nl( user_error ),
	write( user_error, model_llhood_eff(Mst,LLst) ), nl( user_error ),
	model_llhood_eff(Mst,LLst),  % compute log-likelihood of Mst
	write( user_error, llst(LLst) ), nl( user_error ),
	( (LLi = -inf,LLst = -inf) ->  
		Ratio is 1
		;
		( (LLi=:=0,LLst=:=0) ->
			Ratio is 1
			;
			Ratio is exp(LLst - LLi)
		)
	).

model_llhood_eff(Model,LLH) :-
	once( model_llhood_cached(Model,LLH) ),
	!.
model_llhood_eff(Model,LLH) :-
	model_llhood(Model,LLH),
	assert(model_llhood_cached(Model,LLH)).

:- ensure_loaded( 'efficient/ped_likelihood' ). % defines model_llhood/2
