:- module( wm, [rev_w_member_unit/3] ).

/*
compile( rev_w_member_unit ), save_modules( [wm], rev_w_member_unit ), halt.
*/

rev_w_member_unit( [], Nm/Dnm, Dnm/Nm ) :-
	\+ ( Nm =:= 0, Dnm =:= 1 ).
rev_w_member_unit( [_H-Hw|T], Acc, Unit ) :-
	rationals_addition( 1/Hw, Acc, NxAcc ),
	rev_w_member_unit( T, NxAcc, Unit ).

rationals_addition( LNom/LDnm, RNom/RDnm, Simplified ) :-
	rationals_lcd_factors( LDnm, RDnm, ResDnm, LFctr, RFctr ),
	ResNom is LNom * LFctr + RNom * RFctr,
	rationals_simplify( ResNom/ResDnm, Simplified ).

rationals_lcd_factors( NatOne, NatTwo, LCD, OneFact, TwoFact ) :-
	gcd( NatOne, NatTwo, GCD ),
	OneFact is NatTwo // GCD,
	TwoFact is NatOne // GCD,
	LCD is OneFact * TwoFact * GCD.

rationals_simplify( Nom/Dnm, SNom/SDnm ) :-
	gcd( Nom, Dnm, Gcd ),
	SNom is Nom // Gcd,
	SDnm is Dnm // Gcd.

gcd( M, N, C ) :-
        ( N =:= 0 -> C is M
                  ;  NewN is M mod N,
                     gcd( N, NewN, C )
        ).
