:- ensure_loaded( library(lists) ).		% memberchk/2.

:- requires( to_list/2 ).

gnucomfile( GnuComsFile, DataFile ) :-
	tell( GnuComsFile ),
	write( plot ), write( ' \'' ),
	write( DataFile ), write( '\'' ), nl,
	told.

gnucomfile( GnuComsFile, Opts, DataFile ) :-
	tell( GnuComsFile ),
	gnucomfile_options( Opts, DataFile ),
	told.

gnucomfile_w_lines( GnuComsFile, DataFile ) :-
	tell( GnuComsFile ),
	write( plot ), write( ' \'' ),
	write( DataFile ), write( '\' with lines' ), nl,
	told.

gnucomfile_options( Opts, DataFile ) :-
	( memberchk(term(Display),Opts) ->
		write( 'set term ' ), write( Display ), nl
		; 
		true
	),
	( memberchk(output(File),Opts) ->
		write( 'set output \"' ), write( File ),
		write( '\"' ), nl
		; 
		true
	),
	( memberchk(with(uboxes),Opts) -> 
		write( 'unset xtics' ), nl; true),
	% shouldnt be using the following. here just in case
	( (member(set(Set),Opts),write( 'set ' ),
                    ( atomic(Set) -> 
                        write(Set),nl 
                        ;
                        Set =.. [Flag,Arg],
                        write( Flag ), write( ' ' ),
                        write( Arg ), nl
                    ),fail); true ),
	( is_list(DataFile) -> DataFiles = DataFile; 
		DataFiles = [DataFile] ),
	% ( DataFiles = [_F,_S|_] -> write( 'set multiplot' ), nl ; true ),
	write( plot ),
	( memberchk(y(Yl,Yh),Opts) ->
		( memberchk(x(Xl,Xh),Opts) ->
			write_gnuplot_range( Xl, Xh )
			;
			write_gnuplot_range( null, null )
		),
          write_gnuplot_range( Yl, Yh )
		; 
		( memberchk(x(Xl,Xh),Opts) ->
			write_gnuplot_range( Xl, Xh )
			;
			write_gnuplot_range( null, null )
		)
	),
	( memberchk(with(With),Opts) -> true
          % ; ( memberchk(nolines(true),Opts) -> With ='' but must make sureok )
          ; With = lines ),
	write_plot_commands( DataFiles, With ),
	( memberchk(diagonal(Diag),Opts) -> true ; Diag = false ),
	( Diag == true -> 
		write( ', x' ), nl
		;
		nl
	).

write_plot_commands( [], _With ).
write_plot_commands( [DataFile|T], With ) :-
	( DataFile = f(FileName,PrvFOpts) -> 
          to_list( PrvFOpts, FOpts ),
		write( ' \'' ), write( FileName ), write( '\'' ),
		write_file_opts( FOpts ),
		write( ' with ' ), 
		( With == uboxes -> write( boxes ) ; write( With ) ),
		( T == [] -> true ; write( ', ' ) )
		;
		write( ' \'' ), write( DataFile ),
		write( '\' with ' ), 
		( With == uboxes -> write( boxes ) ; write( With ) ),
		( T == [] -> true ; write( ', ' ) )
	),
	write_plot_commands( T, With ).

write_gnuplot_range( Low, High ) :-
	( (Low==null,High==null) -> 	
		write( ' []' )
		;
		write( ' [' ), write( Low ), write( ':' ), 
		write( High ), write( ']' )
	).

% 2005bb18, added this for pt(N). Gnuplot pointtype.
write_file_opts( [] ).
write_file_opts( [H|T] ) :-
	( functor( H, NameH, 1 ) ->
	     arg( 1, H, Arg ),
	     write( ' ' ), write( NameH ), write( ' ' ), 
	     write( Arg ), write( ' ' )
          ;
          functor( H, NameH, 0 ),       % eg notitle
          write( ' ' ), write( NameH ), write( ' ' )
     ),
	write_file_opts( T ).
