/* 
     kv_sum_vs_on_ks( [a-2,a-3,b-4,c-1,c-1], Sums ).
*/
kv_sum_vs_on_ks( KVs, Sums ) :-
     keysort( KVs, Sorted ),
     kvs_sum_vs_on_ks( Sorted, Sums ).

kvs_sum_vs_on_ks( [K-V|T], Sums ) :-
     kvs_sum_vs_on_ks( T, K, V, Sums ).

kvs_sum_vs_on_ks( [], Key, Sum, [Key-Sum] ).
kvs_sum_vs_on_ks( [K-V|T], Key, Val, Sums ) :-
     compare( Op, K, Key ), 
     kvs_sum_vs_on_ks_op( Op, K, V, T, Key, Val, Sums ).

kvs_sum_vs_on_ks_op( <, K, _V, _T, Key, _Sum, _Sums ) :-
     throw( keys_are_not_ordered(Key,K) ).
kvs_sum_vs_on_ks_op( =, K, V, T, _Key, Acc, Sums ) :-
     Sum is Acc + V,
     kvs_sum_vs_on_ks( T, K, Sum, Sums ).
kvs_sum_vs_on_ks_op( >, K, V, T, Key, Sum, [Key-Sum|Sums] ) :-
     kvs_sum_vs_on_ks( T, K, V, Sums ).
